Attribute VB_Name = "Maze"
Option Explicit
 ' The maze information.
Private NumRows As Integer
Private NumCols As Integer
'Private LegalMove() As Boolean
Private arr() As String
 ' The size of a square.
Private Const SQUARE_WID = 20
Private Const SQUARE_HGT = 20
 ' The player's position.
Private PlayerR As Integer
Private PlayerC As Integer
Private StartR As Integer
Private StartC As Integer
 ' The end position.
Private RFinish As Integer
Private CFinish As Integer
 ' The drawing surface.
Private Canvas As Form
Private picPlayer As PictureBox
Private StartTime As Single
Private FileName As String
' Draw the maze.
Private Sub DrawMaze()
Dim r As Integer
Dim c As Integer
Dim clr As Long
    ' Start from scratch.
    Canvas.Cls
    For r = 1 To NumRows
        For c = 1 To NumCols
            'If LegalMove(r, c) Then
            If arr(r, c) <> "I" Then
                If r = RFinish And c = CFinish Then
                    clr = vbYellow
                Else
                    clr = vbWhite
                End If
            Else
                clr = RGB(128, 128, 128)
            End If
            Canvas.Line (c * SQUARE_WID, r * SQUARE_HGT)-Step(-SQUARE_WID, -SQUARE_HGT), clr, BF
        Next c
    Next r
End Sub
Public Sub InitializeMaze(ByVal the_canvas As Form, ByVal pic_player As PictureBox, ByVal file_name As String)
    FileName = file_name
    Set Canvas = the_canvas
    Canvas.ScaleMode = vbPixels
    Canvas.AutoRedraw = True
    Set picPlayer = pic_player
    picPlayer.Visible = False
    ' Load the maze data.
    LoadMaze file_name
End Sub

' Initialize the maze.
Private Sub LoadMaze(ByVal file_name As String)
Dim fnum As Integer
Dim r As Integer
Dim c As Integer
Dim ch As String
Dim row_info As String
 Dim myStr As String
    ' Open the maze file.
    fnum = FreeFile
    Open file_name For Input As #fnum
    ' Read the number of rows and columns.
    Input #fnum, NumRows, NumCols
    ReDim LegalMove(1 To NumRows, 1 To NumCols)
    ReDim arr(1 To NumRows, 1 To NumCols)
    ' Read the data.
    For r = 1 To NumRows
        Line Input #fnum, row_info
        For c = 1 To NumCols
            ch = Mid$(row_info, c, 1)
            LegalMove(r, c) = (ch <> "#")
            
            Select Case ch
              Case "#"
                myStr = "I"  'Illegal
              Case "s", "S"
                myStr = "S"  'Start
              Case "f", "F"
                myStr = "F"  'Finish
              Case " "
                myStr = "C"  'Clear    (Clear path for travel)
              Case Else
                MsgBox "Trouble loading array from  .dat  file"
            End Select
            arr(r, c) = myStr

            If LCase$(ch) = "s" Then
                ' It's the start.
                PlayerR = r
                PlayerC = c
                StartR = r
                StartC = c
            ElseIf LCase$(ch) = "f" Then
                ' It's the finish.
                RFinish = r
                CFinish = c
            End If
        Next c
    Next r
    ' Close the file.
    Close #fnum
    ' Size the form.
    Canvas.Width = Canvas.ScaleX(SQUARE_WID * NumCols, Canvas.ScaleMode, vbTwips) + _
        Canvas.Width - Canvas.ScaleX(Canvas.ScaleWidth, Canvas.ScaleMode, vbTwips)
    Canvas.Height = Canvas.ScaleY(SQUARE_HGT * NumRows, Canvas.ScaleMode, vbTwips) + _
        Canvas.Height - Canvas.ScaleY(Canvas.ScaleHeight, Canvas.ScaleMode, vbTwips)
    ' Draw the maze.
    DrawMaze
    ' Position the player.
    PositionPlayer PlayerR, PlayerC
    ' Save the start time.
    StartTime = Timer
End Sub

Public Sub ProcessMoveKey(KeyCode As Integer)
Dim r As Integer
Dim c As Integer
    r = PlayerR
    c = PlayerC
    Select Case KeyCode
        Case vbKeyLeft
            c = PlayerC - 1
        Case vbKeyRight
            c = PlayerC + 1
        Case vbKeyDown
            r = PlayerR + 1
        Case vbKeyUp
            r = PlayerR - 1
        Case Else
            Exit Sub
    End Select
    'If LegalMove(r, c) Then PositionPlayer r, c
    If arr(r, c) <> "I" Then
      MarkSquareAboutToDepartFrom PlayerR, PlayerC
      PositionPlayer r, c
    End If
End Sub

Public Sub ComputerNavigatesTheMaze()
 Dim r As Integer
 Dim c As Integer
 Dim WhichMoveShouldIMakeNext As Integer
  Do Until arr(PlayerR, PlayerC) = "F"
    r = PlayerR
    c = PlayerC
 
    WhichMoveShouldIMakeNext = DesirableMove(PlayerR, PlayerC)
    Select Case WhichMoveShouldIMakeNext
    Case 1
        r = PlayerR + 1
    Case 2
        r = PlayerR - 1
    Case 3
        c = PlayerC + 1
    Case 4
        c = PlayerC - 1
    Case Else
      MsgBox WhichMoveShouldIMakeNext, vbCritical, "Next Move outside expected range"
    End Select
    'If arr(r, c) <> "I" Then
      MarkSquareAboutToDepartFrom PlayerR, PlayerC
      PositionPlayer r, c
    'End If
  Loop
End Sub

'Pass me curent pos, and I will check adjacent squares for "C" or then "B"
Private Function DesirableMove(PlayerR As Integer, PlayerC As Integer) As Integer
 Dim r As Integer
 Dim c As Integer
                         'If    I, C, B, C
 Dim NumOfC As Integer   '                   then   NumOfC = 2
 Dim NumOfB As Integer   '                   then   NumOfB = 1
 Dim RandomSelectionFromNumOf '              then  Randomly get 1 or 2
 Dim CntrPosition        '                   CntrPosition of the last C would be 2
 Dim arrayContents(1 To 4) As String
 Dim Content As String
 Dim i As Integer
  arrayContents(1) = arr(PlayerR + 1, PlayerC)
  arrayContents(2) = arr(PlayerR - 1, PlayerC)
  arrayContents(3) = arr(PlayerR, PlayerC + 1)
  arrayContents(4) = arr(PlayerR, PlayerC - 1)
  
  For i = 1 To 4
    Content = arrayContents(i)
    Select Case Content
      Case "F"
        DesirableMove = i
        Exit Function          '<================  Exit Function
      Case "C"
        NumOfC = NumOfC + 1
      Case "B"
        NumOfB = NumOfB + 1
    End Select
  Next i
  'If only one C then make it the DesirableMove
  If NumOfC = 1 Then
    For i = 1 To 4
      Content = arrayContents(i)
      Select Case Content
        Case "C"
        DesirableMove = i
        Exit Function          '<================  Exit Function
      End Select
    Next i
  End If
  'If multiple C then randomly choose one as DesirableMove
  If NumOfC > 1 Then
    RandomSelectionFromNumOf = CInt(REUSRandomNumberGenerator(CLng(NumOfC)))
    For i = 1 To 4
      Content = arrayContents(i)
      Select Case Content
        Case "C"
        CntrPosition = CntrPosition + 1  'Incrementing when a "C" is present
        'If count of C's matches Random decision as to which one to take, then take it
        If CntrPosition = RandomSelectionFromNumOf Then
          DesirableMove = i
          Exit Function          '<================  Exit Function
        End If
      End Select
    Next i
  End If

  'If only one B then make it the DesirableMove
  If NumOfB = 1 Then
    For i = 1 To 4
      Content = arrayContents(i)
      Select Case Content
        Case "B"
        DesirableMove = i
        Exit Function          '<================  Exit Function
      End Select
    Next i
  End If
  'If multiple B then randomly choose one as DesirableMove
  CntrPosition = 0
  If NumOfB > 1 Then
    RandomSelectionFromNumOf = CInt(REUSRandomNumberGenerator(CLng(NumOfB)))
    For i = 1 To 4
      Content = arrayContents(i)
      Select Case Content
        Case "B"
        CntrPosition = CntrPosition + 1  'Incrementing when a "C" is present
        'If count of C's matches Random decision as to which one to take, then take it
        If CntrPosition = RandomSelectionFromNumOf Then
          DesirableMove = i
          Exit Function          '<================  Exit Function
        End If
      End Select
    Next i
  End If
 Stop  'Should never get to here

End Function

Private Function REUSRandomNumberGenerator(UpperLimit As Long) As Long
  Randomize   ' Initialize random-number generator(uses Timer).
  REUSRandomNumberGenerator = Int((UpperLimit * Rnd) + 1)   ' Generate random value between 1 and UpperLimit
End Function


'Pass me (depart from) current pos, and I will Mark that square either "I"  or  "B"
'If surrounded by 3 Illegals then mark "I"
'Else mark "B"
Private Sub MarkSquareAboutToDepartFrom(r As Integer, c As Integer)
  If arr(r, c) = "F" Then
    Exit Sub         '<=========== Exit Sub
  End If
 Dim nuIs As Integer
  If arr(r + 1, c) = "I" Then
   nuIs = nuIs + 1
  End If
  If arr(r - 1, c) = "I" Then
   nuIs = nuIs + 1
  End If
  If arr(r, c + 1) = "I" Then
   nuIs = nuIs + 1
  End If
  If arr(r, c - 1) = "I" Then
   nuIs = nuIs + 1
  End If
  If nuIs = 3 Then
    arr(r, c) = "I"    'Mark as Illegal from now on
  Else
    arr(r, c) = "B"    'Mark as Been
  End If
End Sub



' Draw the player.
Private Sub PositionPlayer(r As Integer, c As Integer)
Dim x As Single
Dim y As Single
 Dim intTimeTaken As Integer
 Dim myLong As Long
    ' Erase the player's old position.
    If PlayerR > 0 Then
        x = (PlayerC - 1) * SQUARE_WID + (SQUARE_WID - picPlayer.Width) / 2
        y = (PlayerR - 1) * SQUARE_HGT + (SQUARE_HGT - picPlayer.Height) / 2
        Canvas.Line (x - 1, y - 1)-Step(picPlayer.Width, picPlayer.Height), vbWhite, BF
    End If
    ' Move the player.
    PlayerR = r
    PlayerC = c
    ' Draw the player.
    x = (c - 1) * SQUARE_WID + (SQUARE_WID - picPlayer.Width) / 2
    y = (r - 1) * SQUARE_HGT + (SQUARE_HGT - picPlayer.Height) / 2
    Canvas.PaintPicture picPlayer.Picture, x, y
  For myLong = 1 To 1000000
    'Delay so User can see moves.
  Next myLong
  DoEvents
    ' See if the player reached the finish.
    If r = RFinish And c = CFinish Then
'        If MsgBox("You finished in " & _
'            Int(Timer - StartTime) & " seconds." & _
'            vbCrLf & "Play again?", vbYesNo, _
'            "Congratulations") = vbYes _
'        Then
'            ' Start over.
'            PlayerR = StartR
'            PlayerC = StartC
'            StartTime = Timer 'Rob added this
'            DrawMaze
'            PositionPlayer PlayerR, PlayerC
'        Else
'            Unload Canvas
'        End If
        intTimeTaken = Int(Timer - StartTime)
        MsgBox "You finished in " & intTimeTaken & " seconds.", , "Congratulations"
    End If
End Sub
